LOCALS
.MODEL SMALL
.486
.CODE
ORG 100H

F   equ DL
A   equ BYTE PTR DS:[DI]
BC  equ WORD PTR DS:[DI+2]
B   equ BYTE PTR DS:[DI+3]
C   equ BYTE PTR DS:[DI+2]
DE  equ WORD PTR DS:[DI+4]
D   equ BYTE PTR DS:[DI+5]
E   equ BYTE PTR DS:[DI+4]
HL  equ WORD PTR DS:[DI+6]
H   equ BYTE PTR DS:[DI+7]
L   equ BYTE PTR DS:[DI+6]
AFp equ WORD PTR DS:[DI+8]
Ap  equ BYTE PTR DS:[DI+9]
Fp  equ BYTE PTR DS:[DI+8]
BCp equ WORD PTR DS:[DI+10]
Bpp equ BYTE PTR DS:[DI+11]
Cp  equ BYTE PTR DS:[DI+10]
DEp equ WORD PTR DS:[DI+12]
Dpp equ BYTE PTR DS:[DI+13]
Ep  equ BYTE PTR DS:[DI+12]
HLp equ WORD PTR DS:[DI+14]
Hp  equ BYTE PTR DS:[DI+15]
Lp  equ BYTE PTR DS:[DI+14]
IX  equ WORD PTR DS:[DI+16]
IY  equ WORD PTR DS:[DI+18]
IR  equ WORD PTR DS:[DI+20]
I   equ BYTE PTR DS:[DI+21]
RD  equ BYTE PTR DS:[114h]
TIM equ WORD PTR DS:[DI+22]
TIEM equ WORD PTR DS:[DI+24]

PRB equ BYTE PTR DS:[DI+27]
POR equ BYTE PTR DS:[DI+28]
POC equ BYTE PTR CS:[11Ch]

START:  mov     ax,cs
        add     ah,010h
        mov     es,ax
        mov     ax,13h
        int     10h
        db      0D6h
        mov     si,offset @juego
        mov     cx,8000h
        mov     di,cx
        rep     stosw
        mov     ch,10h
        push    di
        rep     movsw
        pop     si
        db      0D6h
        mov     dx,3C8h
        out     dx,al
        inc     dx
        mov     ch,31h
        call    @repi
        call    @otra
        mov     ax,3509h
        push    es
        int     21h
        mov     word ptr ds:[IRQ9SEG],es
        mov     word ptr ds:[IRQ9OFF],bx
        mov     ah,25h
        mov     dx,offset NewInt9
        int     21h
        pop     es

@DECO:  MOV     DI,100h
        CMP     DH,112
        JC      @SIGE
        SUB     DH,112

@llkk:  db 0D6h
        out 43h,al
        in al,40h
        mov ah,al
        in al,40h
        xchg al,ah
        mov cx,ax
        sub cx,TIEM
        jnc @kakl
        not cx
@kakl:  cmp cx,38
        jc @llkk
        mov TIEM,ax

        IN      AL,61h
        AND     AL,11111100b
        TEST    POR,10h
        JZ      @CERO
        OR      AL,2
@CERO:  OUT     61h,AL
        MOV     AX,TIM
        INC     TIM
        CMP     AX,624
        JNZ     @SIGE
        MOV     AL,POR
        DB      68h
        DW      0A000h
        POP     DS
        MOV     CX,4*320
        PUSH    CX
        XOR     DI,DI
@CCL1:  MOV     BYTE PTR DS:[DI],AL
        INC     DI
        LOOP    @CCL1
        POP     CX
        MOV     DI,320*196
@CCL2:  MOV     BYTE PTR DS:[DI],AL
        INC     DI
        LOOP    @CCL2
        MOV     cl,192

@LUPA:  PUSH    CX
        MOV     AX,CX
        NEG     AX
        ADD     AX,196
        MOV     DI,AX     ;APUNTAREMOS A LA PANTALLA
        XCHG    AH,AL    ;MULTIPLICAMOS AX POR 256
        SHL     DI,6      ;MULTIPLICAMOS DI POR 64
        ADD     DI,AX     ;DI YA ESTA CALCULADO DI=320*line
        SUB     AH,4
        MOV     AL,POC    ;EN AL EL COLOR DEL BORDE "POR"
        MOV     CL,32     ;CX = 32 PUNTOS QUE HAY DE BORDE IZDO
@CCLO:  MOV     BYTE PTR DS:[DI],AL   ;PINTO UN PUNTO
        INC     DI        ;INCREMENTO POSICION
        LOOP    @CCLO    ;REPITO 32 VECES
        PUSH    AX
        MOV     CL,AH
        AND     AH,11000000b
        MOV     BX,CX
        AND     BL,111b
        SHL     BL,3
        SHR     CL,3
        PUSH    CX
        AND     CL,111b
        OR      BL,CL
        OR      BL,AH
        MOV     BH,2
        SHL     BX,5
        POP     AX
        SHL     AX,5
        ADD     AH,58h
        MOV     CL,32     ;CX=32= NUMERO DE CARACTERES A PINTAR
        PUSH    DX
@LIN1:  PUSH    CX       ;GUARDAMOS EN PILA
        XCHG    AX,BX    ;AX=ATTRIB  BX=BYTECARAC
        MOV     DH,ES:[BX];DH=ATRIBUTO
        XCHG    AX,BX    ;BX=ATTRIB  AX=BYTECARAC
        INC     AX        ;INCREMENTO BYTECARAC
        MOV     CH,DH
        AND     CH,111b
        MOV     CL,DH
        AND     CL,38h
        SHR     CL,3
        TEST    DH,40h
        JZ      @LIN2
        OR      CH,01000b
@LIN2:  ROL     BYTE PTR ES:[BX],1
        JC      @PIFO
        MOV     BYTE PTR DS:[DI],CL
        DB      3Dh
@PIFO:  MOV     BYTE PTR DS:[DI],CH
@PIPI:  INC     DI
        TEST    DI,111b
        JNZ     @LIN2
        POP     CX
        INC     BX          ;INCREMENTO ATRIBUTO
        LOOP    @LIN1      ;REPITO 32 VECES
        POP     DX
        POP     AX
        MOV     CL,32
@CCLP:  MOV     BYTE PTR DS:[DI],AL
        INC     DI
        LOOP    @CCLP
        POP     CX
        DEC     CX
        JNZ     @LUPA  ;;;loop lupa
        PUSH    CS
        POP     DS
        MOV     DI,100h
        MOV     TIM,CX

@SIGE:  CMP     BYTE PTR DS:[OFFSET TECLA],1h
        JNZ     @SDEC
@SALIR: MOV     DX,WORD PTR DS:[IRQ9OFF]
        MOV     DS,WORD PTR DS:[IRQ9SEG]
        MOV     AX,2509h
        INT     21h
        AAD     0F2h
        INT     10h
        xor     bx,bx
        push    cs
        pop     ds
        MOV     SI,OFFSET PRESENTA
@PRN:   DB      68h
        DW      0B7F0h
        POP     ES
@STA:   lodsb
        mov     ah,al
        db      0B0h
@ST:    STOSW
@RP:    LODSB
        cmp     al,24
        jc      @STA
        jnz     @ST
        ret

@OTRA:  MOV CH,03Fh
@REPI:  MOV AL,BL
        OUT DX,AL
        MOV AL,BH
        OUT DX,AL
        MOV AL,CL
        OUT DX,AL
        XOR CL,CH
        JNZ @REPI
        XOR BL,CH
        JNZ @REPI
        XOR BH,CH
        JNZ @REPI
        RET


@SDEC:  DB 68h
        DW OFFSET @DECO
        MOV PRB,6
@ABAPRE:MOV BX,102h
        XOR AX,AX
        AND CX,AX
        ADD DH,4
        DB 026h
        LODSB
        SHL AL,1
        JNC @S
@N:     SHL AL,1          ;80-FF
        JNC _CALC     ;
@NN:    add dh,6
        SHR AL,3          ;C0-FF
        JNC @NNL      ;
@NNH:   SHR AL,1          ;C0-FF impares
        JC @NNHH      ;
@NNHL:  SHR AL,1          ;C0-FF imp*par C1,C5,C9,CD,D1,D5,D9,DD,E1,E5,E9,ED,F1,F5,F9,FD 
        JNC @NNHLL    ;
@NNHLH: SHR AL,1          ;C0-FF imp*par*imp  C5,CD,D5,DD,E5,ED,F5,FD
        JNC _PUSH     ;
@NNHLHH:SHR AL,1          ;C0-FF imp*par*imp*imp  CD,DD,ED,FD
        JC _DDFD
        JZ _CALNN     ;    ;C0-FF imp*par*imp*imp*par  CD,ED 
;;ED PREFIX
_EDPR:  ADD DH,4      ;tarda 4 ciclos de reloj el fetch
        DB 026h       ;prefijo ES:
        LODSB         ;busca instruccin
        SHL AL,1      
        JC _N         
_S:     SHL AL,1      ;00-7F
        JNC _NAD
_SN:    SHR AL,3      ;40-7F
        JC _SNH
_SNL:   SHR AL,1      ;40 42 44 46 48 ...
        JC _SNLH
_SNLL:  SHR AL,1      ;40 44 48 4C 50
        JC _NEG
;;IN S,(C) ;ED 40,48,50,58,60,68,70,78 "IN S,(C)" S=B,C,D,E,H,L,A
_INSC:  add dh,4
        ADD BX,AX
        AND BL,111b
        XOR BL,BH
_ED70:  DB 68h;CALL @PINBC
        DW OFFSET @DERE
@PINBC: MOV AX,BC
@PIN:   PUSH DI
        CMP AL,0FEh
        JNZ @TTTW
        MOV CL,0BFh
        MOV DI,OFFSET TECLADO
@RUTL:  SHR AH,1
        JC @NAND
        AND CL,BYTE PTR DS:[DI]
@NAND:  INC DI
        SHR AL,1
        JNZ @RUTL
        XCHG AX,CX
@NKEM:  POP DI
        RET
@TTTW:  CMP AL,1Fh
        JNZ @NKEM
        DB 0D6h
        POP DI
        RET
@DERE:  MOV [BX],AL
_NAD:   RET
;;NEG ;ED 44,4C,54,5C,64,6C,74,7C "NEG"
_NEG:   XCHG CH,A
        MOV CL,010000b
        JMP @OPER;
_SNLH:  SHR AL,1       ;42 46 4A 4E 52 56 5A ....
;;ADC,SBC HL,SS ;ED 42,4A,52,5A,62,6A,72,7A "ADC,SBB HL,SS"  SS=BC,DE,HL,SP
_ADSBC: add dh,7
        MOV CH,11h   ;11h=OPCODE ADC
        SHR AL,1
        JC @SBBB;;;;
        MOV CX,1902h   ;19h=OPCODE SBB
@SBBB:  MOV BYTE PTR DS:[OFFSET @SUMO],CH
        ADD AL,AL
        ADD BX,AX
        CMP AL,6
        MOV AX,WORD PTR DS:[BX]
        JNZ @SBAC
        MOV AX,BP
@SBAC:  ror F,1                  ;paso el C del z80 al PC
@SUMO:  adc HL,ax
        lahf
        PUSHF
        and     ah,11111001b    ;Overflow  N a 0
        POPF
        jNo @cafi
        or      ah,00000100b    ;Overflow a 1
@cafi:  mov     F,ah
        OR F,CL
        RET
_SNH:   SHR AL,1               ;41 43 45 47 49 4B 4D..
        JC _SNHH   ;
_SNHL:  SHR AL,1               ;41 45 49 4D 51 55 ..
        JC @SIRE
;;OUT (C),S   ;OP ED 41,49,51,59,61,69,79 "OUT (C),S" S=B,C,D,E,H,L,A   12
_OUTCS: add dh,4
        ADD BX,AX
        AND BX,111b
        JZ _OUT0
        XOR BL,BH
        MOV AL,BYTE PTR DS:[BX]
        DB 03Dh;SALTO SIG INST
_OUT0:  XOR AL,AL       ;ED 71
@POUTBC:MOV AH,C
@POUT:  SHR AH,1        ;ENTRADA AH=DIREC PUERTO AL=BYTE
        JC @LARE
        AND AL,11110111b
        MOV POR,AL
@LARE:  RET
;;RETI, RETN   ;OP ED 45,4D,55,5D,65,6D,75,7D
_SNHH:  SHR AL,2           ;43 47 4B 4F 53 57 ..
        JC _LSSNN
;;LD (NN),SS   ;OP ED 43,53,63,73 "LD (NN),SS"  SS=BC,DE,HL,SP
_LNNSS: ADD AL,AL
        ADD BX,AX           
        CMP AL,6
        MOV AX,WORD PTR DS:[BX]
        JNZ @SBAD  ;;;;;;@LDIM DIRECTO
        MOV AX,BP
@SBAD:  JMP @LDIM
;;LD SS,(NN)   ;OP ED 4B,5B,6B,7B "LD SS,(NN)"  SS=BC,DE,HL,SP
_LSSNN: ADD AL,AL
        ADD BX,AX
        CMP AL,6
        JNZ @LDIX
        DB 26h;ES:
        LODSW
        XCHG BX,AX
        MOV BP,WORD PTR ES:[BX]  ;OP ED 7B "LD SP,(NN)"
        RET
_2RET:   RET

_N:     SHL AL,1        ;80-FF
        JC _2RET
        SUB AL,80h      ;80-BF
        SHL AL,1
        JC _2RET
        add dh,8
        SHR AL,4        ;A0-BF > 00-1F
        JC _NH
_NL:    SHR AL,1        ;A0 A2 A4 A6 A8 ..
        JC _NLH   ;
        SHR AL,1        ;A0 A4 A8 AC B0 B4..
        JC _2RET
;;LD??   ;OP A0 A8 B0 B8 "LDI,LDD,LDIR,LDDR" BX=0,1,2,3
_LDILD: SHR AL,1
        MOV BX,HL       
        MOV BL,BYTE PTR ES:[BX]
        PUSH DI
        MOV DI,DE
        XCHG AX,BX
        STOSB
        POP DI
        JC @OIOD  ;FLAG ARRASTRADO 9 LINEAS ARRIBA
        INC DE
        INC HL
        JMP SHORT @OOOI
@OIOD:  DEC DE
        DEC HL
@OOOI:  AND F,11000001b  ;TODOS MENOS SZC A LA MIERDA
        DEC BC
        JZ _3RET
        OR F,00000100b
        SHR BL,1
        JNC _3RET
@CORE:  add DH,5
        SUB SI,2;VUELVO A DECODIF LA MISMA INSTRUCCION
_3RET:  RET;
_NLH:   SHR AL,1        ;A2 A6 AA AE B2 B6
        JC _3RET
;;IN??   ;OP A2 AA B2 BA "INI,IND,INIR,INDR"
_INIR:  PUSH AX
        CALL @PINBC
        MOV BX,HL
        MOV BYTE PTR ES:[BX],AL
@LMQI:  POP AX
        SHR AL,1
        JC @CIAD
        INC HL
        JMP @MIER
@CIAD:  DEC HL
@MIER:  OR DL,01000010b ;Z Y N A TRUE
        DEC B
        LAHF
        AND DL,10111111b
        AND AH,01000000b
        OR DL,AH
        SHL AH,1
        JS @RTIT
        SHR AL,1
        JC @CORE
@RTIT:  RET;
_NH:    SHR AL,1   ; A1 A3 A5 A7 A9 AB ..
        JNC _NHL
_NHH:   SHR AL,1   ; A3 A7 AB AF B3 ..
        JC @RTIT
;;OUT??  ;OP A3 AB B3 BB "OUTI,OUTD,OTIR,OTDR"
_OUTIR: PUSH AX
        MOV BX,HL
        MOV AL,BYTE PTR ES:[BX]
        CALL @POUTBC
        JMP @LMQI  ;
_NHL:   SHR AL,1
        JC @RTIT
;;CP??  ;OP A1 A9 B1 B9 "CPI,CPD,CPIR,CPDR"
_CPIR:  SHR AL,1
        XCHG AX,CX
        MOV DI,HL
        JC @CIOD
        INC WORD PTR DS:[BX+4];HL
        JMP @MDDM
@CIOD:  DEC WORD PTR DS:[BX+4];HL
@MDDM:  MOV AL,[BX-2]
        SCASB
        LAHF                     ; X VELOCIDAD CON CALL OPER TB VALE
        AND AX,0101000010101000b
        OR AL,AH
        OR AL,100b ; PV LO PONGO A 1
        AND F,BH
        OR F,AL
        DEC WORD PTR DS:[BX];BC
        JZ @CPIR
        JCXZ @CPIR
        TEST F,01000000b  ;MIRO SI FLAG Z=1 SALGO
        JZ @CORE
@CPIR:  RET        ;
;;DD FD PREFIX
_DDFD:  sub dh,6
        ADD AL,AL  ;        ;DD FD PREFIJOS
        ADD AL,10h
        MOV PRB,AL
        JMP @ABAPRE;
;;PUSH SS  ;C5,D5,E5,F5 > 00 01 02 03  BC,DE,HL,AF
_PUSH:  inc dh
        CMP AL,2
        JC @NANH
        MOV BL,PRB
        JZ _PUSHDA
        MOV AH,A    ;PUSH AF
        MOV AL,F
        JMP _PUSHDX
@NANH:  ADD AL,AL
        ADD BX,AX
_PUSHDA:MOV AX,[BX]
_PUSHDX:DEC BP
        DEC BP
@ESBP:  CMP BP,04000h
        JC @SA04
        MOV WORD PTR ES:[BP],AX
@SA04:  RET
@NNHLL: SHR AL,1     ;C1,C9,D1,D9,E1,E9,F1,F9
        JC @NNHLLH ; ;C1,D1,E1,F1 > 00 40 80 C0
;;POP XX  ;C1 D1 E1 F1
_POPXX: MOV CX,WORD PTR ES:[BP]
        INC BP
        INC BP
        CMP AL,2
        JC @NAN2
        MOV BL,PRB
        JZ _POPDA
        MOV A,CH  ;POP AF
        MOV DL,CL
        RET
@NAN2:  ADD AL,AL
@POPDE: ADD BX,AX
_POPDA: MOV WORD PTR DS:[BX],CX
        RET;
@NNHLLH:SHR AL,1               ;C9,D9,E9,F9 > 00 40 80 C0
        JC @NNHLLHH
        JZ _RET
;;JP (HL)  ;OP E9
_JPHL:  sub dh,6
        MOV BL,PRB
        MOV SI,WORD PTR DS:[BX]
        RET;
;;RET c/Nc  ;OPS C0,C8,D0,D8,E0,E8,F0,F8 *
_RETNC: sub dh,5
        MOV BX,OFFSET FLCMP
        SHR AL,1
        XLAT      
        JNC @SISI
        TEST F,AL
        JZ @NORE
        JNZ @SIRE
@SISI:  TEST F,AL
        JNZ @NORE
@SIRE:  add DH,6;5+6=11
;;RET  ;OP C9 *
_RET:   MOV SI,WORD PTR ES:[BP] 
        INC BP
        INC BP
@NORE:  RET;
@NNHLLHH:JNZ _LSPHL   ;D9,F9 > 00 80
;;EXX  ;OP D9 *"EXX" BC DE HL
_EXX:   sub dh,6
        MOV CL,3
@LOO3:  MOV AX,WORD PTR DS:[BX]
        XOR BL,8
        XCHG AX,WORD PTR DS:[BX]
        XOR BL,8
        MOV WORD PTR DS:[BX],AX
        ADD BL,2
        LOOP @LOO3
        RET;
;;LD SP,HL    ;OP F9 *
_LSPHL: sub dh,4
        MOV BL,PRB
        MOV BP,[BX]
        RET;
@NNHH:  SHR AL,1         ;C3,C7,CB,CF,D....,E....,F.......
        JNC @NNHHL
;;RST XX  ;OP C7,CF,D7,DF,E7,EF,F7,FF *"RST" XX= 00 08 10 18 ...
_RST:   inc dh
        SHL AL,3
        DEC BP
        DEC BP
        XCHG SI,AX
        JMP @ESBP;
@NNHHL: SHR AL,1         ;C3,CB,D3,DB,E3,EB,F3,FB @NNNNSS
        JNC @NNHHLL  ;
@NNHHLH:SHR AL,1         ;CB,DB,EB,FB  00 40 80 C0
        JC @NNHHLHH  ;
        JNZ _EXDHL   ;   ;CB,EB
;;CB PREFIX
_PRCB:  add dh,4
        MOV BL,PRB       ;OP CB PREFIJO CB
        MOV DI,WORD PTR DS:[BX]  ;ch=0;MODO DE ENTRADA NORMAL (SOLO 1 OPERACION)
        CMP BL,06h
        JZ @OPOC
        DEC RD      ;SI EL PREFIJO EXISTE CALCULAR DESPLAZ IX+d
        add dh,8
        MOV CH,1  ;MODO DE ENTRADA CON PREFIJO (2 OPERACIONES)
        DB 026h;ES:
        LODSB
        CBW
        ADD DI,AX ;;;;;;;;;;;;,ARREGLAR TODO ESTO
@OPOC:  INC RD
        DB 026h;ES:               ;CH=0 HL CH=1 IX CH=2 IY
        LODSB
        MOV BH,AL    ;ETO E MUY COMPLICAO
        MOV AH,1
        ADD AL,2     
        AND AL,111b  ;HL A B C D E H L
        JNZ @DES0
        add dh,7
        MOV CH,1     ;SIMULAMOS QUE ES UN PREFIJO
@DES0:  XOR AL,1     ;A HL C B E D L H
        XCHG BX,AX
        SHR AX,6    ;AH 0-3 OPCODE ; AL 0-8 MODO
        SHR AL,5
        OR AH,AH
        JNZ @ROTE
        PUSH BX               ;ROTACIONES  00-3F
        MOV BX,OFFSET ROTEMO
        CMP AL,6   ;SLL RARO UNDOCUMENTADO
        JNZ @UNOR
        MOV F,1
@UNOR:  XLAT    ;AL OPCODE INSTR ROTAR
        POP BX
        OR CH,CH   ;COMPROBAR SI HAY PREFIJO
        JNZ @IXIY
        MOV BYTE PTR DS:[@RTAD+1],AL
        SHR F,1
@RTAD:  RCL BYTE PTR DS:[BX],1
        MOV AL,BYTE PTR DS:[BX]
@TSIG:  RCL F,1
        AND F,1;;;BUSCAR UN UNO EN OTRO REG
        OR AL,AL
        JNZ @ZEFL
        OR F,01000000b
        OR AL,AL
@ZEFL:  JPO @ZEFM
        OR F,00000100b
@ZEFM:  AND AL,10101000b
        OR F,AL
        RET
@IXIY:  SUB AL,2
        MOV BYTE PTR DS:[@RTXY+2],AL
        SHR F,1
@RTXY:  RCL BYTE PTR ES:[DI],1
        MOV AL,BYTE PTR ES:[DI]
        MOV BYTE PTR DS:[BX],AL
        JMP @TSIG
ROTEMO  DB 7,0Fh,17h,1Fh,27h,3Fh,17h,2Fh ;;;;METER EN OTRO LADO
@ROTE:  MOV CL,1
        XCHG CX,AX
        SHL AL,CL
        DEC CH           ;COMPARACIONES DE BITS 40-7F
        JNZ @BITC
        sub dh,3
        OR AH,AH
        JZ @IXY1+1  ;SI NORMAL COJO DE DS:BX
        MOV BX,DI    ;SI PREFIJO COJO DE ES:DI
@IXY1:  TEST AL,BYTE PTR ES:[BX];;;NUEVO
        jnz      @@bitun
        and     F,11111101b ;N a 0
        or      F,01010000b ;H Z a 1
        jmp @@FinOp
@@bitun:and     F,10111101b ;N Z a 0
        or      F,00010000b ;H a 1
@@FinOp:ret
@BITC:  DEC CH       ;PONER 0 O 1?
        JNZ @REST
        NOT AL
        DEC AH  ;PREFIJOS?
        JNZ @IXY2
        AND BYTE PTR ES:[DI],AL
@IXY2:  AND BYTE PTR DS:[BX],AL
        RET
@REST:  DEC AH      ;PUESTA A 1 DE BIT C0-FF
        JNZ @IXY3
        OR BYTE PTR ES:[DI],AL    ;;BBBBB
@IXY3:  OR BYTE PTR DS:[BX],AL
        RET;
;;EX DE,HL  ;OP EB *
_EXDHL: sub dh,6
        MOV BL,PRB
        MOV AX,DE
        XCHG AX,WORD PTR DS:[BX]
        MOV DE,AX
        RET;
@NNHHLHH:JNZ _NAD    ;DB,FB
;;IN A,(N)  ;OP DB
_INAN:  inc dh
        DB 026h;ES:
        LODSB
        MOV AH,A
        CALL @PIN
        MOV A,AL
        RET;
@NNHHLL:SHR AL,1      ;C3,D3,E3,F3
        JC @NNHHLLH
@NNHHLLL:JZ _JUNP        ;C3,E3
;;EX (SP),HL  ;OP E3 *
_EXPHL: add dh,9
        MOV BL,PRB
        MOV AX,WORD PTR ES:[BP]
        XCHG AX,WORD PTR DS:[BX]
        JMP @ESBP;
@NNHHLLH:
;;OUT (N),A  ;OP D3 *
_OUTNA: inc dh ;add dx,di
        DB 26h;ES:
        LODSB
        MOV AH,AL
        MOV AL,A
        JMP @POUT;
OPCOS   DB 0,10h,28h,18h,20h,30h,8,38h
FLCMP   DB 40h,1,4;,80h OJO CON ESTE TRUCO;;;;;;NO QUITAR DE AQUI
@NNL:   SHR AL,1        ;C0-FF pares C0 C2 C4 C6 C8 CA ...
        JC @NNLH
@NNLL:  SHR AL,1        ;C0 C4 C8 CC D0 D4 D8 *
        JNC _RETNC
;;CALL Nc NN  ;OPS C4,CC,D4,DC,E4,EC,F4,FC ;
_CALLC: MOV BX,OFFSET FLCMP
        SHR AL,1  
        XLAT
        JNC @ZZSI
        TEST F,AL
        JZ @NOXX
        JNZ @SIZZ
@ZZSI:  TEST F,AL
        JNZ @NOXX
@SIZZ:  add DH,7;10+7=17
;;CALL NN  ;OP CD
_CALNN: add dh,7
        DB 26h;ES:
        LODSW
        DEC BP
        DEC BP
        XCHG SI,AX
        JMP @ESBP;
@NNLH:  SHR AL,1        ;C2 C6 CA CD D2 D6 DA ..
        JC _WOPER
;;JP Nc   ;OPS C2,CA,D2,DA,E2,EA,F2,FA  ;
_JPCNC: MOV BX,OFFSET FLCMP
        SHR AL,1
        XLAT
        JNC @XXSI
        TEST F,AL
        JZ @NOXX
        JNZ _JUNP
@XXSI:  TEST F,AL
        JNZ @NOXX
_JUNP:  MOV SI,WORD PTR ES:[SI] ;OP C3 "JP NN"  ;4 =1
        RET
@NOXX:  CMPSW
        RET;
;;ADD SUB ADC SBB AND OR XOR CP A,N ;OPS C6,CE,D6,DE,E6,EE,F6,FE *;12 =3
_WOPER: sub dh,3
        DEC SI
        DB 26h
        LODSW
        XCHG CX,AX
        JMP @OPER;
;;"ADD,ADC,SUB,SBC,AND,XOR,OR,CP" ;OP 80-BF
_CALC:  SHR AL,2
        MOV CL,AL
        ADD AX,BX ;OP 80-BF "ADD,ADC,SUB,SBC,AND,XOR,OR,CP" ;62 =16
        AND AL,111b
        PUSHF
        XOR AL,AH ;1
        CMP AL,6
        JC @MAL2
        SUB AL,6
        ADD AL,PRB
@MAL2:  POPF
        XCHG BX,AX
        JNZ @NNE7
        add dh,3
        CALL @SAIXD
        DB 26h;ES:
@NNE7:  MOV CH,BYTE PTR DS:[BX]
@OPER:  SHR CL,3 ;AL VIENE SUMADO A 32
        AND CL,111b ;SI VIENE DE WOPER
        MOV AL,CL
        MOV BX,OFFSET OPCOS;CH=NUMERO A SUMAR.  CL=OPERACION
        XLAT
        MOV BYTE PTR DS:[@ASAS],AL
        MOV BX,0000101000000001b  ;CARRY ANTERIOR
        SHL BL,CL  ;;;;;;;;;;;;;SUPONGO QUE CARRY=0
        TEST BH,BL
        JZ @NFLA
        MOV AL,F
        SHR AL,1
@NFLA:  MOV AL,A
@ASAS:  DW 0E800h ; OPER AL,CH
        MOV A,AL
@FLAG:  PUSHF         ;FLAGS Z A O C= Z H PV C ;CL OPERACION ;AL RESULTADO ;SALIDA FLAGS CAMBIADOS 
        POP BX        ;BL FLAGS PC                       ;55 =14
        OR BH,BL
        AND BH,00001100b ;BIT 3 OVERFLOW BIT 2 PARITY
        XCHG AL,BH
        AND BX,0010100011010001b  ;FLAG 5 3 YA PUESTOS LOS DEMAS A 0
        OR BL,BH          ;PONGO FLAGS FILTRADOS
        INC CX
        AND CL,111b
        CMP CL,5
        JNC @LOGI
        SHR AL,1          ;OPERACION ARITMETICA PASO OVERFLOW A PV
        JMP @MDDC
@LOGI:  AND BL,11101111b  ;PONGO A 0 EL BIT H SI SE TRATA DE OPER LOGICA
@MDDC:  AND AL,00000100b  ;FILTRO PV
        OR BL,AL          ;METO EL FLAG PV
        MOV AL,1  ;PONGO BIT 0 DE AL A 1
        SHL AL,CL
        TEST AL,00011001b  ;XOR,OR,AND,SBB,SUB,ADC,ADD,CP
        JZ @NFNN
        OR BL,10b         ;METO FLAG N
@NFNN:  AND AL,00100000b  ;XOR,OR,AND,SBB,SUB,ADC,ADD,CP
        SHR AL,1
        OR AL,BL          ;BIT H PUESTO SI LA OPERACION ES AND
@NFHH:  MOV F,AL;   MOV F,AL       ;LO PONGO EN FLAGS
        RET;
@S:     SHL AL,1
        JC _LDR_R
@SS:    SHR AL,3   ;00 01 02 03 04
        JC @SSH
@SSL:   SHR AL,1   ;00 02 04 06 08
        JC @SSLH
@SSLL:  SHR AL,1   ;00 04 08 0C 10
        JC _INCRU
@SSLLL: SHR AL,1   ;00 08 10 18 20 28 30 38
        JC @SSLLLH
@SSLLLL:SHR AL,1   ;00 10 20 30
        JC @SSLLLLH
@SSLLLLL:JZ _NOP
;;JR NZ,dis ;OP 20
_JNZ:   add dh,3
        TEST F,01000000b
@AJMP:  JZ _JUMP
@INRE:  INC SI
_NOP:   RET;
@SSLLLLH:JZ _DJNZ
;;JR NC,dis ;OP 30
_JNC:   add dh,3
        TEST F,00000001b
        JMP @AJMP;
;;DJNZ (LOOP)  ;OP 10
_DJNZ:  add dh,4
        DEC B
        JZ @INRE
;;JP dis (JMP) ;OP 18 "JMP"
_JUMP:  add dh,5
        DB 26h;ES:
        LODSB
        CBW
        ADD SI,AX
        RET;
@SSLLLH:adc dh,bl;3
        SHR AL,1          ;08 18 28 38
        JC @SSLLLHH
@SSLLLHL:JZ _EXAF ;08 28
;;JM NC (JS)  ;OP 28
_JZ:    TEST F,01000000b
@BJMP:  JNZ _JUMP
        JZ @INRE;
;;EX AF,AF'  ;OP 08 "EX AF,AF'"
_EXAF:  sub dh,3
        MOV AH,A
        MOV AL,F
        XCHG AX,[DI+8]
        MOV A,AH
        MOV F,AL
        RET;
@SSLLLHH:JZ _JUMP;18 38
;;JP NC (JC/JNC) ;OP 38
_JC:    TEST F,00000001b
        JMP @BJMP
;;INC/DEC B,C,D,E,A,(HL) ;04,0C,14,1C,24,2C,34,3C
_DECRU: MOV CL,BL
_INCRU: AND F,BH;1
        OR F,CL;DE PUTISIMA MADRE
        SHL CL,CL ;SOY LA CAA
        OR CL,111b
        MOV BYTE PTR DS:[@INHL+1],CL
        ADD BX,AX
        AND BL,111b
        JNZ @HLSF
        add dh,7      ;34 35
        CALL @SAIXD
        PUSH ES
        POP DS
        JMP @INHL
@HLSF:  XOR BL,BH;;;;;1
        CMP BL,6
        JC @INHL
        inc dh
        SUB BL,6
        ADD BL,PRB
@INHL:  INC BYTE PTR DS:[BX]
        MOV BL,BYTE PTR DS:[BX]
        PUSH CS
        POP DS
        PUSHF
        POP AX
        AND AX,0000100011010000b
        SHR AH,1
        OR AL,AH
        AND BL,00101000b
        OR AL,BL
        OR F,AL
        RET;
@SSLH:  SHR AL,1                ;02 06 0A 0E 12
        JNC @SSLHL
;;LD X,N  ;X=B,C,D,E,H,L,X,A ;OP 06,0E,16,1E,26,2E,XX,3E
_LDXN:  adc dh,bl
        ADD AX,BX
        AND AL,111b
        JZ _LDHLN
        XOR AL,AH
        CMP AL,6
        JC @MALO
        sub dh,bl;2
        SUB AL,6
        ADD AL,PRB
@MALO:  XCHG BX,AX
        DB 26h;ES:
        LODSB
        MOV BYTE PTR DS:[BX],AL
        RET;
@SSLHL: SHR AL,1                ;02 0A 12 1A
        JC @SSLHLH
@SSLHLL:CMP AL,2       ;02 12 22 32
        JNC @2232
;;LD (BC/DE),A   ;OPS 02,12
_LDXXA: adc dh,bl ;3
        ADD AL,AL
        ADD BX,AX
        MOV AL,A
        MOV DI,WORD PTR DS:[BX]
        JMP @ESDB;
@2232:  JNZ _LDNNA
;;LD (NN),HL   ;OP 22
_LNNHL: MOV BL,PRB
        MOV AX,[BX]
@LDIM:  add dh,12
        XCHG DI,AX
        DB 26h;ES:
        LODSW
        CMP AH,40h
        XCHG DI,AX
        JC @NST0
        STOSW
@NST0:  RET;
;;LD (NN),A  ;OP 32
_LDNNA: add dh,9
        DB 026h;ES:
        LODSW
        MOV DI,[DI]
        XCHG AX,DI
        JMP @ESDB;
@SSLHLH:CMP AL,2                       ;0A 1A 2A 3A
        JNC @2A3A
;;LD A,(BC/DE)  ;OPS 0A,1A
_LDAXX: adc dh,bl
        ADD AL,AL
        ADD BX,AX
        MOV BX,WORD PTR DS:[BX]
        MOV AL,BYTE PTR ES:[BX]
        MOV A,AL
        RET;
@2A3A:  JNZ _LDANN
;;LD HL,(NN) ;OP 2A
_LHLNN: MOV BL,PRB
@LDIX:  add dh,12
        DB 26h;ES:
        LODSW
        XCHG DI,AX
        MOV AX,WORD PTR ES:[DI]
        MOV WORD PTR DS:[BX],AX
        RET;
;;LD A,(NN)  ;OP 3A
_LDANN: add dh,9
        DB 26h;ES:
        LODSW
        XCHG AX,BX
        MOV AL,ES:[BX]
        MOV A,AL
        RET;
;;LD (HL),N  ;OP 36
_LDHLN: add dh,3
        CALL @SAIXD ;;;;me falta un puto ciclo
        CMP BH,40h
        JC @INRE
        MOV DI,BX
        DB 26h
        MOVSB
        RET;
@SSH:   SHR AL,1         ;01 03 05 07 ...
        JC @SSHH
@SSHL:  SHR AL,1         ;01 05 09 0D 11 ...
        JC _DECRU
@SSHLL: SHR AL,1         ;01 09 11 19...
        JC _AHLSS
;;LD XX,NN ;XX=BC,DE,HL,SP  ;01 11 21 31
_LRRNN: ADD DH,6
        CMP AL,2
        JNZ _CNTI
        MOV BL,PRB
        JZ @D222
_CNTI:  JC _NLDS
_LDSPN: DB 26h  ; OP 31 "LD SP,NN"
        LODSW
        XCHG BP,AX
        RET
_NLDS:  ADD AL,AL    ;OPS 01,11,21 "LD RR,NN"  ;19        +1
        ADD BX,AX
@D222:  DB 26h;ES:
        LODSW
        MOV WORD PTR DS:[BX],AX
        RET;
;;ADD RR,NN  ;OPS 09,19,29,39
_AHLSS: add dh,7
        CMP AL,2
        JC _ADHL
        JNZ _AHLSP
        MOV BL,PRB
        JMP @D244;
;;ADD HL,BC/DE  ;09 19
_ADHL:  ADD AL,AL
        ADD BX,AX
@D244:  MOV AX,WORD PTR DS:[BX]
@SUMA:  MOV BL,PRB
        and    F,11101100b   ; H N C a cero por ahora
        ADD WORD PTR DS:[BX],AX
        jnc   @DD16
        or     F,00000001b   ;Meto el C
@DD16:  RET;
_AHLSP: MOV AX,BP  ;39
        JMP @SUMA;
;;DEC B,C,D,E,A,(HL) ;05 0D 15 1D 25 2D 35 3D;;;;;;;;CONJUNTAR CON EL INCREMENTO
@SSHH:  SHR AL,1                   ;03 07 0B 0F 13 ...
        JC @SSHHH
@SSHHL: add dh,bl
        CMP AL,6                   ;03 0B 13 1B 23 2B 33 3B
        JNC _SPLH
;;INC/DEC BC/DE/HL  ;OPS 03,0B,13,1B,23 2B
        SHR AL,1
        RCL CL,4
        OR CL,7
        MOV BYTE PTR DS:[@HL01+1],CL
_INCXX: ADD AL,AL
        ADD AX,BX
        CMP AL,6
        MOV BL,PRB
        JZ @HL01
        XCHG BX,AX
@HL01:  INC WORD PTR DS:[BX]
        RET;
_SPLH:  JNZ _DECSP
;;INC SP   ;OP 33
_INCSP: INC BP
        INC BP;;;;;;;;;;;;COMPRIME MEJOR.RET;
;;DEC SP   ;OP 3B
_DECSP: DEC BP
        RET;
@SSHHH: CMP AL,4          ;07,0F,17,1F,27,2F
        JNC @SHHHL
;;RLCA RRCA RLA RRA  ;OP 07,0F,17,1F
_RLCA:  SHL AL,3
        OR AL,5
        MOV BYTE PTR DS:[OFFSET @MAG2+1],AL
        AND F,11000101b
        ROR F,1
@MAG2:  ROL A,1
        RCL F,1
        MOV AL,A
        AND AL,00101000b
        OR F,AL
        RET;
@SHHHL: CMP AL,5      ;27 2F 37 3F 47 4F
        JNC @NO27
;;DAA   ;OP 27
_DAA:   MOV AH,F
        AND F,2
        MOV AL,F
        ADD AL,F;SHL AL,1
        ADD AL,27h
        MOV BYTE PTR DS:[DAAI],AL
        SAHF
        MOV AL,A
DAAI:   DAA
        MOV A,AL
        LAHF
        AND AX,1101010100101000b
        OR AL,AH
        OR F,AL
        RET;
@NO27:  JNZ _SCF
;;CPL  ;OP 2F
_CPL:   NOT A
        MOV AL,A
        AND AL,00101000b
        OR AL,00010010b
        AND F,11000101b
        OR F,AL
        RET;
;;SCF/CCF  ;OP 37 3F
_SCF:   AND F,11101101b     ;H N a 0
        SHR AL,1
        JC CCF
SCF:    OR  F,BH;1          ;C a 1
        RET
CCF:    TEST F,BH;1
        JZ SCF
        or  F,00010000b     ;H a 1
        DEC DX ;;;;;;;LA CHAPUZA DEL SIGLO  ;C a 0
        RET;
;;LD R,R   ;OP 40-7F
_LDR_R: MOV CL,6
        SHR AL,2
        PUSH AX
        ADD AX,BX
        MOV BL,PRB
        AND AL,111b
        JZ @ATAJ
        XOR AL,AH    
        CMP BL,CL    ;A (HL) B C D E H L
        JZ @OTCO
        CMP AL,CL
        JC @OTCO
        sub dh,2 ;;;oreg=2
        SUB AL,CL    ; H L > 6 7
        ADD AL,BL    ;
@OTCO:  XCHG AX,BX
        JMP @EHDD
@ATAJ:  add dh,3
        MOV CL,8
        CALL @SAIXD     ;46 4E 56 5E 66 6E
@AEHH:  DB 26h
@EHDD:  MOV CH,[BX]
        POP AX
        SHR AL,3    ;EN BX CONSERVO FUENTE DATO
        ADD AL,2
        AND AL,111b
        JZ @HHHH      ;DESTINO (HL) O (IX+D)
        XOR AL,1
        CMP PRB,CL
        JZ @OTC2
        CMP AL,CL
        JC @OTC2
        SUB AL,CL
        ADD AL,PRB
@OTC2:  ADD DI,AX
        MOV BYTE PTR DS:[DI],CH
        RET
@HHHH:  add dh,3
        CMP CL,8
        JZ _HALT  ;DESTINO=(HL),ORIGEN=(HL)
        MOV AL,CH
        CMP BL,8  ;DESTINO=(IX+D),ORIGEN =IXh/IXl
        JC @RECA
        DB 0D6h;
        AND BL,BH
        ADD BL,CL
        XLAT
@RECA:  DB 68h
        DW OFFSET @DEPU
@SAIXD: MOV BL,PRB
        CMP BL,6
        MOV BX,WORD PTR DS:[BX]
        JZ @INPX
        add DH,8
        PUSH AX
        DB 26h;ES:
        LODSB
        CBW
        ADD BX,AX
        POP AX
@INPX:  RET
@DEPU:  MOV DI,BX
@ESDB:  CMP DI,4000h  ;LO PUEDO QUITAR LUEGO
        JC @NST1
        STOSB
@NST1:  RET
_HALT:  sub dh,6
        DEC SI                 ;OP 76 HALT      ;4 =1
        RET;

NewInt9:PUSH AX
        PUSH CX
        IN AL,60h
        MOV BYTE PTR CS:[OFFSET TECLA],AL
        MOV CL,3 ;BANCO 3
        SHL AX,1
        AND AH,1
        SHR AL,1
        SUB AL,2   ;0-2
        CMP AL,5   ;2-6
        JL @DPAF
        INC CX
        SUB AL,5   ;2-7
        CMP AL,5   ;7-B
        JNL @SIPO
@DPNE:  NOT AL
        ADD AL,5
@DPAF:  MOV CH,1;;;;;;
        XCHG AX,CX
        SHL AH,CL
        PUSH BX
        MOV BX,OFFSET TECLADO
        ADD BL,AL
        MOV AL,BYTE PTR CS:[BX]
        SHR CH,1
        JC @MAKE
        NOT AH
        AND AL,AH
        DB 3Dh
@MAKE:  OR AL,AH
        MOV BYTE PTR CS:[BX],AL
        POP BX
@FINS:  MOV AL,20h
        OUT 20h,AL
        POP CX
        POP AX
        STI
        IRET
@SIPO:  MOV CL,2
        SUB AL,9     ;7-10
        CMP AL,5     ;10-14
        JL @DPAF
        MOV CL,5
        SUB AL,CL;5  ;10-15
        CMP AL,CL;5  ;15-19
        JL @DPNE
        MOV CL,6
        SUB AL,7     ;15-1C
        JZ @DPAF
        INC CX
        CMP AL,1
        JZ @DPAF
        MOV CL,1
        SUB AL,2     ;1C-1E
        CMP AL,5
        JL @DPAF
        MOV CL,6
        SUB AL,5     ;1E-23
        CMP AL,4     ;23-26
        JL @DPNE
        XOR CL,CL
        SUB AL,7     ;23-2A
        JZ @DPAF
        DEC AX       ;2A-2B
        CMP AL,5     ;2B-2F
        JL @DPAF
        MOV CL,7
        SUB AL,5     ;2B-30
        CMP AL,3
        JL @DPNE
        SUB AL,9
        JZ @DPAF     ;39
        JMP @FINS
@juego:
DB 049,000,240,205,253,143,205
DB 144,144,033,000,000,034,002,192,034,000,192,195,104,130,253,033
DB 005,192,205,039,128,253,033,007,192,205,039,128,253,033,009,192
DB 253,110,000,253,102,001,126,183,200,094,035,086,035,078,035,070
DB 035,205,198,145,126,183,032,241,035,253,117,000,253,116,001,201
DB 033,000,000,034,000,192,062,001,050,018,192,062,003,050,017,192
DB 205,203,144,205,230,144,033,230,154,205,159,144,033,068,155,205
DB 159,144,033,232,003,034,015,192,175,050,027,192,050,026,192,050
DB 130,192,050,133,192,050,020,192,050,019,192,050,022,192,050,023
DB 192,050,024,192,050,125,192,062,001,050,013,192,205,234,129,205
DB 125,133,205,145,133,205,091,137,205,203,144,205,230,144,205,129
DB 143,205,227,141,205,097,142,175,050,130,192,050,133,192,205,188
DB 134,205,143,143,205,227,141,205,111,137,205,082,138,205,245,136
DB 205,083,140,205,218,134,205,234,133,205,117,134,205,035,136,205
DB 194,133,205,078,134,205,227,139,205,047,133,205,211,132,205,154
DB 132,205,044,142,205,017,141,205,099,141,058,125,192,183,194,218
DB 129,058,024,192,183,194,164,129,058,026,192,183,040,176,001,020
DB 000,197,205,032,130,193,011,120,177,194,008,129,042,015,192,124
DB 181,040,040,229,205,066,130,033,118,129,034,007,192,225,001,010
DB 000,183,237,066,034,015,192,237,091,000,192,019,237,083,000,192
DB 124,181,194,026,129,205,066,130,205,066,130,058,018,192,060,050
DB 018,192,245,230,003,033,132,129,204,114,129,241,230,252,202,105
DB 128,230,012,079,006,000,009,094,035,086,035,229,235,205,159,144
DB 225,094,035,086,235,205,159,144,195,105,128,033,148,129,201,044
DB 001,005,000,220,005,001,000,200,000,005,000,000,000,144,158,166
DB 158,100,158,122,158,188,158,210,158,224,157,246,157,180,157,202
DB 157,012,158,034,158,136,157,158,157,056,158,078,158,006,010,033
DB 182,129,034,009,192,197,205,032,130,193,016,249,195,105,128,238
DB 000,020,000,000,212,000,020,000,000,189,000,020,000,000,178,000
DB 020,000,000,159,000,020,000,000,142,000,020,000,000,126,000,020
DB 000,000,000,205,167,143,058,017,192,061,183,050,017,192,040,041
DB 195,105,128,058,018,192,254,006,056,002,062,005,061,135,033,006
DB 130,079,006,000,009,126,050,021,192,035,126,050,025,192,201,001
DB 016,002,021,003,026,002,031,004,036,001,005,000,197,205,032,130
DB 193,011,120,177,032,246,195,104,130,205,188,134,205,143,143,205
DB 227,141,205,082,138,205,234,133,205,117,134,205,035,136,205,227
DB 139,205,111,137,205,044,142,205,017,141,201,205,188,134,205,143
DB 143,205,227,141,205,234,133,205,117,134,205,227,139,205,044,142
DB 205,017,141,201,119,183,200,205,045,145,183,032,247,225,195,071
DB 128,205,203,144,205,230,144,033,226,145,205,159,144,205,102,132
DB 205,082,132,062,255,050,004,192,205,045,145,033,004,192,190,196
DB 091,130,205,188,134,001,140,195,022,192,030,137,123,002,003,021
DB 032,250,033,126,132,126,060,040,020,061,095,035,070,035,078,035
DB 205,177,144,123,229,213,205,197,139,209,225,024,232,033,018,131
DB 205,003,131,001,166,197,042,002,192,205,085,143,001,230,197,042
DB 000,192,205,085,143,001,109,196,062,140,205,197,139,205,082,138
DB 205,035,136,058,113,192,183,032,016,058,112,192,238,002,050,112
DB 192,058,090,192,238,002,050,090,192,001,125,196,062,010,205,197
DB 139,001,133,196,062,014,205,197,139,195,127,130,126,060,200,070
DB 035,078,035,205,177,144,205,195,144,024,241,010,007,085,080,000
DB 010,026,072,085,068,083,079,078,000,011,005,016,020,020,020,017
DB 000,011,020,066,079,077,066,000,012,005,021,087,025,073,022,000
DB 012,017,016,020,020,020,020,020,017,032,032,032,083,079,070,084
DB 000,013,001,076,069,070,084,018,020,020,020,019,082,073,071,072
DB 084,032,032,021,083,080,065,067,069,022,000,014,000,016,020,020
DB 020,017,032,032,032,032,032,016,020,020,020,017,032,032,018,020
DB 020,020,020,020,019,032,032,032,001,009,008,003,000,015,000,021
DB 065,025,074,022,032,032,032,032,032,021,068,025,076,022,000,016
DB 000,018,020,020,020,019,032,032,032,032,032,018,020,020,020,019
DB 032,032,072,073,064,083,067,079,082,069,033,000,017,005,016,020
DB 020,020,017,000,018,005,021,088,025,077,022,000,018,020,083,067
DB 079,082,069,033,000,019,005,018,020,020,020,019,000,020,005,068
DB 079,087,078,032,032,080,082,079,071,082,065,077,077,069,082,033
DB 089,025,084,065,078,065,075,065,000,023,001,080,085,083,072,032
DB 083,080,065,067,069,064,075,069,089,032,084,079,032,083,084,065
DB 082,084,032,071,065,077,069,000,021,022,084,025,083,065,083,065
DB 071,065,087,065,000,007,003,066,079,077,066,069,082,032,032,032
DB 001,048,064,032,032,032,032,066,079,078,085,083,032,032,032,069
DB 088,073,084,000,008,005,077,065,078,032,032,032,032,002,048,048
DB 032,032,032,032,032,049,080,084,083,000,255,205,091,137,221,033
DB 091,192,221,054,000,001,221,054,001,017,221,054,002,010,201,205
DB 125,133,221,033,030,192,221,054,000,001,221,054,001,010,221,054
DB 002,007,221,054,003,001,201,034,002,002,036,002,005,038,002,008
DB 034,002,011,040,002,014,042,002,017,038,002,022,044,002,025,046
DB 002,028,255,058,123,192,183,192,042,015,192,124,181,040,009,001
DB 010,000,237,066,034,015,192,201,058,027,192,183,192,205,129,143
DB 062,001,050,027,192,175,050,133,192,050,130,192,062,001,050,022
DB 192,050,023,192,175,050,129,192,050,131,192,201,237,075,011,192
DB 058,133,192,183,040,022,058,132,192,184,032,016,058,131,192,185
DB 032,010,175,050,133,192,062,001,050,024,192,201,058,130,192,183
DB 200,058,129,192,184,192,058,128,192,185,192,175,050,130,192,205
DB 037,143,230,063,135,203,231,079,006,000,042,000,192,009,034,000
DB 192,033,031,133,034,005,192,201,212,000,020,000,000,178,000,020
DB 000,000,142,000,020,000,000,000,058,019,192,183,200,058,020,192
DB 183,192,237,075,028,192,205,155,143,205,156,134,254,032,192,058
DB 021,192,198,004,050,021,192,221,033,030,192,022,004,221,126,000
DB 060,040,029,061,032,019,221,054,000,001,058,028,192,221,119,001
DB 058,029,192,221,119,002,021,040,007,001,007,000,221,009,024,221
DB 062,001,050,020,192,201,221,033,030,192,221,126,000,060,200,221
DB 054,000,000,001,007,000,221,009,024,240,058,021,192,071,221,033
DB 030,192,033,186,133,205,037,143,230,003,135,133,111,126,221,119
DB 001,035,126,221,119,002,221,054,000,001,017,007,000,221,025,005
DB 032,224,201,001,001,029,001,001,019,029,019,058,022,192,183,192
DB 237,075,128,192,080,089,205,155,143,205,156,134,254,032,192,066
DB 075,205,177,144,205,156,134,254,032,192,062,001,050,130,192,050
DB 022,192,201,058,130,192,183,200,237,091,128,192,066,075,205,177
DB 144,062,010,205,018,134,003,060,205,018,134,033,031,000,009,068
DB 077,198,015,205,018,134,003,060,195,018,134,245,010,254,224,056
DB 021,175,050,130,192,058,128,192,050,028,192,058,129,192,050,029
DB 192,062,001,050,019,192,241,002,201,245,010,254,224,056,021,175
DB 050,133,192,058,131,192,050,028,192,058,132,192,050,029,192,062
DB 001,050,019,192,241,002,201,058,023,192,183,192,237,075,131,192
DB 080,089,205,155,143,205,156,134,254,032,192,066,075,205,177,144
DB 205,156,134,254,032,192,062,001,050,133,192,050,023,192,058,133
DB 192,183,200,237,075,131,192,205,177,144,062,014,205,048,134,003
DB 060,205,048,134,033,031,000,009,068,077,198,015,205,048,134,003
DB 060,205,048,134,201,010,254,032,192,003,010,254,032,192,033,031
DB 000,009,068,077,010,254,032,192,003,010,201,126,060,035,190,056
DB 001,175,043,119,201,033,113,192,205,178,134,033,119,192,205,178
DB 134,033,123,192,205,178,134,033,121,192,205,178,134,205,230,144
DB 195,021,128,058,119,192,183,192,058,090,192,238,002,050,090,192
DB 221,033,030,192,221,126,000,060,200,061,254,001,194,167,135,221
DB 126,004,061,087,254,255,032,017,221,126,003,061,254,255,032,002
DB 062,003,221,119,003,058,025,192,087,122,221,119,004,221,126,003
DB 183,040,008,058,119,192,230,003,194,167,135,221,126,003,183,040
DB 065,221,126,004,230,015,183,040,057,230,003,183,040,032,205,202
DB 135,254,128,048,005,205,175,135,024,102,205,037,143,230,003,221
DB 119,005,205,202,135,254,128,048,087,205,175,135,024,082,205,037
DB 143,230,003,221,119,005,205,202,135,254,128,048,067,205,175,135
DB 024,062,058,011,192,071,221,126,001,184,040,019,048,006,221,054
DB 005,001,024,004,221,054,005,000,205,202,135,254,128,056,030,058
DB 012,192,071,221,126,002,184,040,023,048,006,221,054,005,003,024
DB 004,221,054,005,002,205,202,135,254,128,210,167,135,205,175,135
DB 001,007,000,221,009,195,235,134,221,126,005,135,033,027,136,006
DB 000,079,009,221,126,002,134,221,119,002,035,221,126,001,134,221
DB 119,001,201,033,011,136,221,126,005,135,135,079,006,000,009,221
DB 126,002,134,071,035,221,126,001,134,079,197,205,177,144,010,193
DB 254,128,208,205,155,143,010,254,128,208,035,221,126,002,134,071
DB 035,221,126,001,134,079,197,205,177,144,010,193,254,128,208,205
DB 155,143,010,201,000,255,001,255,000,002,001,002,255,000,255,001
DB 002,000,002,001,000,255,000,001,255,000,001,000,221,033,030,192
DB 221,126,000,060,200,061,202,224,136,254,001,202,180,136,221,078
DB 001,221,070,002,205,177,144,221,126,000,135,198,030,254,048,056
DB 007,062,032,205,214,139,024,003,205,197,139,229,033,117,192,205
DB 178,134,225,058,117,192,183,194,224,136,221,126,000,060,254,010
DB 040,021,221,119,000,135,135,135,135,095,022,000,197,001,015,000
DB 205,198,145,193,195,224,136,175,221,119,000,221,126,003,135,135
DB 060,060,071,205,037,143,230,003,060,128,079,006,000,042,000,192
DB 009,034,000,192,058,013,192,254,006,048,062,058,021,192,061,050
DB 021,192,032,053,058,026,192,060,050,026,192,024,044,221,078,001
DB 221,070,002,205,177,144,221,126,003,135,135,198,192,033,090,192
DB 134,205,232,136,060,003,205,232,136,033,031,000,009,068,077,198
DB 015,205,232,136,003,060,205,232,136,001,007,000,221,009,195,039
DB 136,245,010,254,224,056,004,221,054,000,002,241,002,201,058,013
DB 192,254,006,208,058,018,192,230,003,040,005,205,045,145,060,192
DB 221,033,091,192,221,126,000,060,200,061,183,032,059,237,075,011
DB 192,221,113,001,221,112,002,205,155,143,080,089,205,087,137,192
DB 003,205,087,137,192,033,031,000,009,068,077,205,087,137,192,003
DB 205,087,137,192,066,075,062,096,205,197,139,062,001,221,119,000
DB 175,221,119,003,050,013,192,201,001,004,000,221,009,195,011,137
DB 010,254,032,201,221,033,091,192,221,126,000,060,200,221,054,000
DB 000,001,004,000,221,009,024,240,058,112,192,238,002,050,112,192
DB 221,033,091,192,221,126,000,060,200,061,040,057,254,005,048,011
DB 221,126,003,060,221,119,003,254,007,032,042,175,221,119,003,058
DB 121,192,183,032,032,221,126,000,060,254,014,040,020,221,119,000
DB 254,005,056,017,254,006,040,020,058,013,192,254,006,048,006,024
DB 004,175,221,119,000,001,004,000,221,009,024,184,033,203,137,034
DB 007,192,024,241,080,000,008,000,160,000,008,000,064,001,008,000
DB 128,002,008,000,000,198,002,004,000,042,003,004,000,000,208,002
DB 003,000,052,003,003,000,000,218,002,003,000,062,003,003,000,000
DB 228,002,003,000,072,003,003,000,000,238,002,002,000,082,003,002
DB 000,000,248,002,002,000,092,003,002,000,000,002,003,002,000,102
DB 003,002,000,000,012,003,002,000,112,003,002,000,000,022,003,002
DB 000,122,003,002,000,000,032,003,001,000,132,003,001,000,000,042
DB 003,001,000,142,003,001,000,000,052,003,001,000,152,003,001,000
DB 000,062,003,001,000,162,003,001,000,000,000,221,033,091,192,221
DB 126,000,060,200,061,040,082,254,013,040,098,254,005,056,008,135
DB 198,214,217,087,217,024,104,061,135,135,087,058,112,192,130,198
DB 096,087,217,087,217,221,126,001,079,217,079,217,221,126,002,071
DB 217,071,217,205,155,143,205,183,138,003,020,205,183,138,033,031
DB 000,009,068,077,062,015,130,087,205,183,138,003,020,205,183,138
DB 217,205,177,144,122,205,197,139,217,001,004,000,221,009,024,159
DB 010,254,224,216,221,054,000,004,221,054,003,006,201,221,126,001
DB 079,221,126,002,071,205,155,143,062,032,205,214,139,024,218,221
DB 078,001,221,070,002,205,155,143,217,122,217,205,197,139,217,122
DB 217,060,060,254,240,056,002,062,032,217,095,217,033,185,143,126
DB 183,040,004,135,183,040,178,126,035,221,134,002,071,126,035,221
DB 134,001,079,205,107,139,254,136,032,014,024,004,254,137,032,008
DB 035,035,035,035,035,035,024,215,126,035,221,134,002,071,126,035
DB 221,134,001,079,205,107,139,254,128,056,010,254,138,048,006,035
DB 035,035,035,024,186,126,035,221,134,002,071,126,035,221,134,001
DB 079,205,164,139,008,254,128,056,009,254,138,048,005,008,035,035
DB 024,157,008,126,035,221,134,002,071,126,035,221,134,001,079,205
DB 164,139,024,139,197,205,177,144,010,193,254,136,200,254,137,200
DB 205,155,143,010,254,136,200,254,128,056,006,254,138,048,002,024
DB 005,217,123,217,024,009,205,152,139,254,136,032,002,062,032,002
DB 201,245,227,058,121,192,183,032,001,036,227,241,201,197,205,177
DB 144,010,008,010,008,193,254,136,200,254,137,200,205,155,143,010
DB 254,138,048,005,254,128,056,001,201,217,123,217,002,201,002,003
DB 060,002,033,031,000,009,068,077,198,015,002,003,060,002,201,002
DB 003,002,033,031,000,009,068,077,002,003,002,201,058,013,192,254
DB 006,048,033,254,002,048,015,183,032,008,060,050,013,192,030,138
DB 024,026,030,140,024,022,061,061,135,135,198,160,095,058,014,192
DB 131,095,024,008,214,006,135,095,062,078,147,095,058,012,192,071
DB 058,011,192,079,205,177,144,205,053,140,205,053,140,033,030,000
DB 009,068,077,123,198,014,095,205,053,140,205,053,140,201,010,087
DB 123,002,003,028,122,254,192,216,058,013,192,254,006,208,062,006
DB 050,013,192,201,000,001,255,000,001,000,000,255,058,113,192,183
DB 192,058,013,192,254,006,056,041,254,013,040,031,033,115,192,205
DB 178,134,058,115,192,183,192,058,013,192,060,050,013,192,135,135
DB 135,095,022,000,001,015,000,205,198,145,201,062,001,050,125,192
DB 201,006,002,205,079,145,254,005,040,014,004,254,007,040,009,004
DB 254,003,040,004,004,254,001,192,058,014,192,238,002,050,014,192
DB 033,075,140,120,095,061,061,135,006,000,079,009,058,011,192,134
DB 079,058,012,192,035,134,071,197,205,177,144,022,000,205,000,141
DB 205,000,141,033,030,000,009,068,077,205,000,141,205,000,141,122
DB 183,193,192,120,050,012,192,121,050,011,192,123,050,013,192,006
DB 008,058,014,192,203,039,203,039,203,039,246,064,095,022,000,197
DB 001,005,000,205,198,145,193,201,201,010,003,254,136,032,001,020
DB 254,137,032,001,020,254,128,192,020,201,001,141,195,033,179,141
DB 205,195,144,001,153,195,033,186,141,205,195,144,001,165,195,033
DB 194,141,205,195,144,001,170,195,058,018,192,205,069,143,237,075
DB 000,192,042,002,192,237,066,048,004,237,067,002,192,001,147,195
DB 042,000,192,205,085,143,001,160,195,042,015,192,205,085,143,011
DB 062,032,002,001,109,198,033,200,141,195,195,144,058,018,192,230
DB 003,192,001,109,198,058,136,192,183,040,012,033,136,192,205,178
DB 134,033,152,141,195,195,144,096,105,006,026,054,032,035,016,251
DB 033,138,192,205,178,134,058,138,192,183,192,033,136,192,195,178
DB 134,032,032,021,022,150,021,032,149,024,048,022,032,016,020,048
DB 048,151,023,049,032,016,048,149,049,020,032,000,016,017,018,019
DB 020,033,000,032,021,022,023,024,025,033,000,032,016,048,049,033
DB 000,032,021,022,150,021,020,019,150,149,023,032,146,024,147,016
DB 018,023,016,018,148,048,032,001,009,008,003,000,062,136,006,032
DB 033,140,195,119,035,016,252,006,032,033,108,198,119,035,016,252
DB 006,023,033,171,195,017,031,000,119,035,119,025,016,250,033,239
DB 195,014,005,062,137,006,007,205,033,142,183,017,029,000,237,082
DB 016,245,017,100,000,025,013,032,236,201,119,035,119,017,031,000
DB 025,119,035,119,201,033,056,142,205,003,131,011,058,017,192,002
DB 201,023,026,032,032,144,033,032,000,255,205,037,143,230,031,254
DB 015,048,247,079,205,037,143,230,031,254,011,048,247,071,201,120
DB 135,198,001,071,121,135,198,001,079,201,205,065,142,121,050,126
DB 192,254,002,056,245,254,013,048,241,120,050,127,192,254,002,056
DB 233,254,009,048,229,205,086,142,197,205,177,144,010,254,032,193
DB 032,216,121,050,011,192,120,050,012,192,062,035,008,205,065,142
DB 080,089,058,126,192,147,048,002,237,068,254,002,048,014,058,127
DB 192,146,048,002,237,068,254,002,048,002,024,225,121,203,071,040
DB 007,120,203,071,032,215,024,005,120,203,071,040,208,205,086,142
DB 033,011,143,126,060,040,015,061,184,032,007,035,126,185,040,189
DB 024,001,035,035,024,237,058,130,192,183,032,013,120,050,129,192
DB 121,050,128,192,062,001,050,130,192,120,050,132,192,121,050,131
DB 192,062,001,050,133,192,205,155,143,062,128,205,214,139,008,061
DB 194,147,142,201,001,003,003,001,019,001,021,003,001,027,003,029
DB 021,027,019,029,255,205,155,143,062,032,205,214,139,201,229,213
DB 197,042,134,192,124,023,023,173,031,245,124,173,103,237,095,173
DB 111,241,203,021,203,020,034,134,192,125,193,209,225,201,254,010
DB 056,010,038,000,111,017,010,000,205,116,143,125,002,201,017,016
DB 039,205,116,143,017,232,003,205,116,143,017,100,000,205,116,143
DB 017,010,000,205,116,143,125,002,003,175,002,003,201,175,183,237
DB 082,056,003,060,024,248,025,002,003,201,033,140,192,017,141,192
DB 001,255,002,054,032,237,176,201,017,140,195,033,140,192,001,000
DB 003,237,176,201,229,205,177,144,033,000,253,009,068,077,225,201
DB 033,000,080,043,124,181,032,251,201,033,000,004,043,124,181,032
DB 251,201,000,255,000,254,000,253,000,252,001,255,001,254,001,253
DB 001,252,000,002,000,003,000,004,000,005,001,002,001,003,001,004
DB 001,005,255,000,254,000,253,000,252,000,255,001,254,001,253,001
DB 252,001,002,000,003,000,004,000,005,000,002,001,003,001,004,001
DB 005,001,128,128,128,128,033,009,144,017,005,192,001,146,000,237
DB 176,201,045,133,045,133,045,133,001,001,002,000,000,000,005,001
DB 000,002,001,000,000,000,031,000,000,000,000,000,003,001,003,005
DB 000,000,000,001,011,002,009,000,000,001,001,001,001,009,000,000
DB 000,007,001,003,005,000,000,000,000,000,002,009,000,000,000,000
DB 000,001,009,000,000,000,000,000,003,005,000,000,000,000,000,002
DB 003,000,000,255,255,255,255,000,000,000,000,000,000,000,000,000
DB 000,000,000,000,000,000,000,000,000,000,000,000,255,000,000,004
DB 000,004,000,007,000,005,000,003,000,050,000,000,000,001,001,000
DB 001,001,000,255,255,000,016,000,008,237,086,251,205,203,144,062
DB 000,211,254,253,033,000,000,201,094,035,086,035,078,035,070,035
DB 229,033,140,201,025,235,225,237,176,201,229,104,038,000,068,041
DB 041,041,041,041,009,001,140,195,009,227,193,201,126,035,183,200
DB 002,003,024,248,033,140,195,017,141,195,001,255,002,062,032,119
DB 237,176,033,140,198,017,141,198,001,255,002,047,119,237,176,017
DB 140,195,033,140,198,217,022,064,001,000,088,217,026,190,119,196
DB 012,145,062,032,018,019,035,217,012,032,240,004,122,198,008,087
DB 254,088,056,231,201,217,213,095,022,000,107,098,041,041,041,025
DB 017,140,201,025,209,089,197,074,006,008,126,018,035,020,016,250
DB 081,193,126,002,217,201,062,254,219,254,230,001,047,200,062,127
DB 219,254,230,001,047,200,175,201,087,073,069,079,068,076,067,014
DB 088,077,090,078,065,074,081,085,205,106,145,229,197,033,063,145
DB 006,016,190,040,005,035,016,250,006,018,062,018,144,015,230,127
DB 193,225,201,197,229,033,158,145,001,254,254,237,120,047,230,031
DB 040,006,015,056,016,035,024,250,035,035,035,035,035,203,000,056
DB 234,175,225,193,201,126,254,032,040,007,254,227,040,003,225,193
DB 201,230,127,040,227,024,222,227,090,088,067,086,065,083,068,070
DB 071,081,087,069,082,084,049,050,051,052,053,048,057,056,055,054
DB 080,079,073,085,089,013,076,075,074,072,032,014,077,078,066,229
DB 062,016,205,216,145,062,000,205,216,145,011,121,176,032,241,225
DB 201,211,254,098,107,043,124,181,032,251,201,000,000,000,009,060
DB 066,070,090,098,066,060,000,071,016,048,080,016,016,016,124,000
DB 071,060,066,002,012,048,064,126,000,071,060,066,002,028,002,066
DB 060,000,071,004,012,020,036,126,004,004,000,071,126,064,120,004
DB 002,068,056,000,071,028,032,064,124,066,066,060,000,071,126,066
DB 004,008,016,016,016,000,071,060,066,066,060,066,066,060,000,071
DB 060,066,066,062,002,004,056,000,071,063,255,064,047,016,015,085
DB 049,070,252,242,009,245,003,254,107,021,070,008,028,062,073,008
DB 008,008,008,071,008,004,006,255,006,004,008,000,071,000,000,117
DB 069,114,069,117,000,071,000,000,119,034,034,034,114,000,071,000
DB 000,000,015,008,008,008,008,071,000,000,000,240,016,016,016,016
DB 071,008,008,008,015,000,000,000,000,071,016,016,016,240,000,000
DB 000,000,071,000,000,000,255,000,000,000,000,071,008,008,008,008
DB 008,008,008,008,071,016,016,016,016,016,016,016,016,071,004,008
DB 016,016,016,008,004,000,071,032,016,008,008,008,016,032,000,071
DB 000,000,000,000,048,048,000,000,071,068,255,128,191,182,191,128
DB 255,070,169,245,021,213,210,212,024,240,070,008,008,008,008,073
DB 062,028,008,071,016,032,096,255,096,032,016,000,071,127,127,127
DB 127,121,121,127,127,068,127,127,127,127,079,079,127,127,068,000
DB 000,000,000,000,000,000,000,064,024,024,024,000,024,024,024,000
DB 071,000,127,127,096,096,096,096,127,067,000,248,248,006,006,006
DB 006,248,067,000,031,031,096,096,096,096,096,067,000,248,248,006
DB 006,006,006,006,067,000,096,096,120,120,102,102,097,067,000,006
DB 006,030,030,102,102,134,067,000,127,127,096,096,096,096,127,067
DB 000,254,254,000,000,000,000,248,067,000,127,127,096,096,096,096
DB 127,067,000,248,248,006,006,006,006,248,067,000,007,007,024,024
DB 096,096,127,067,000,224,224,024,024,006,006,254,067,000,096,096
DB 120,120,102,102,097,067,000,006,006,006,006,006,006,134,067,060
DB 066,070,090,098,066,060,000,071,060,066,002,012,016,000,016,000
DB 071,127,096,096,096,096,127,127,000,067,248,006,006,006,006,248
DB 248,000,067,096,096,096,096,096,031,031,000,067,006,006,006,006
DB 006,248,248,000,067,097,096,096,096,096,096,096,000,067,134,006
DB 006,006,006,006,006,000,067,127,096,096,096,096,127,127,000,067
DB 248,000,000,000,000,254,254,000,067,127,096,096,096,096,096,096
DB 000,067,248,096,096,024,024,006,006,000,067,127,096,096,096,096
DB 096,096,000,067,254,006,006,006,006,006,006,000,067,097,096,096
DB 096,096,096,096,000,067,134,102,102,030,030,006,006,000,067,000
DB 000,000,124,000,000,000,000,071,024,036,066,126,066,066,066,000
DB 071,124,066,066,124,066,066,124,000,071,028,034,064,064,064,034
DB 028,000,071,120,068,066,066,066,068,120,000,071,126,064,064,120
DB 064,064,126,000,071,126,064,064,120,064,064,064,000,071,028,034
DB 064,078,066,034,028,000,071,066,066,066,126,066,066,066,000,071
DB 028,008,008,008,008,008,028,000,071,014,004,004,004,004,068,056
DB 000,071,066,068,072,112,072,068,066,000,071,064,064,064,064,064
DB 064,126,000,071,066,102,090,090,066,066,066,000,071,066,098,082
DB 074,070,066,066,000,071,060,066,066,066,066,066,060,000,071,124
DB 066,066,124,064,064,064,000,071,000,000,000,000,000,000,000,000
DB 064,124,066,066,124,072,068,066,000,071,060,066,064,060,002,066
DB 060,000,071,062,008,008,008,008,008,008,000,071,066,066,066,066
DB 066,066,060,000,071,000,000,000,000,000,000,000,000,064,066,066
DB 066,090,090,102,066,000,071,066,066,036,024,036,066,066,000,071
DB 034,034,034,028,008,008,008,000,071,000,000,000,000,000,000,000
DB 000,064,000,000,000,000,000,000,000,000,064,004,008,016,016,016
DB 008,004,000,071,032,016,008,008,008,016,032,000,071,000,000,000
DB 000,048,048,000,000,071,060,066,002,012,016,000,016,000,071,000
DB 000,001,001,007,031,063,127,069,080,224,080,000,192,240,248,252
DB 069,000,000,001,001,007,031,063,127,069,032,224,032,000,192,240
DB 248,252,069,001,000,001,001,007,031,063,127,069,064,128,064,000
DB 192,240,248,252,069,000,001,000,001,007,031,063,127,069,128,064
DB 128,000,192,240,248,252,069,000,000,001,003,007,031,063,127,069
DB 000,000,000,128,192,240,248,252,069,000,000,000,001,002,007,031
DB 063,069,000,000,000,000,128,192,240,248,069,000,000,001,003,007
DB 031,063,127,069,000,000,000,128,192,240,248,252,069,000,000,000
DB 000,001,003,007,031,069,000,000,000,000,000,128,192,240,069,255
DB 255,255,255,127,063,031,007,069,254,254,254,254,252,248,240,192
DB 069,255,255,255,255,127,063,031,007,069,254,254,254,254,252,248
DB 240,192,069,255,255,255,255,127,063,031,007,069,254,254,254,254
DB 252,248,240,192,069,255,255,255,255,127,063,031,007,069,254,254
DB 254,254,252,248,240,192,069,255,255,255,255,127,063,031,007,069
DB 254,254,254,254,252,248,240,192,069,127,127,127,127,063,031,007
DB 000,069,252,252,252,252,248,240,192,000,069,255,255,255,255,127
DB 063,031,007,069,254,254,254,254,252,248,240,192,069,063,063,063
DB 063,031,007,000,000,069,248,248,248,248,240,192,000,000,069,253
DB 005,253,000,223,080,223,000,066,221,005,253,000,223,080,219,000
DB 066,220,005,253,000,223,080,091,000,066,220,005,125,000,222,080
DB 091,000,066,216,005,093,000,158,080,075,000,066,080,005,080,000
DB 138,080,008,000,066,016,005,080,000,002,080,008,000,066,000,001
DB 064,000,002,064,008,000,066,253,253,253,000,223,223,223,000,067
DB 253,253,253,000,223,223,223,000,066,015,063,015,030,031,014,007
DB 014,071,128,224,128,192,192,128,014,016,071,007,007,031,007,013
DB 015,004,003,071,192,192,240,192,096,224,064,128,071,007,007,031
DB 007,013,015,004,003,071,192,192,240,192,096,224,064,128,071,024
DB 060,024,060,090,060,102,000,068,056,084,124,108,056,016,012,000
DB 066,066,066,066,126,066,066,066,000,071,120,068,066,066,066,068
DB 120,000,071,126,064,064,120,064,064,064,000,071,024,036,066,126
DB 066,066,066,000,071,066,102,090,090,066,066,066,000,071,028,008
DB 008,008,008,008,028,000,071,112,064,112,030,122,010,014,000,068
DB 064,064,120,040,062,010,014,000,068,062,127,121,120,112,112,056
DB 060,068,056,124,254,254,254,124,056,000,069,027,059,107,075,015
DB 014,012,028,068,176,184,172,164,224,224,096,112,068,011,027,059
DB 051,027,015,014,028,068,160,176,184,152,176,224,224,112,068,003
DB 003,015,003,006,007,002,001,071,224,224,248,224,176,240,032,192
DB 071,007,007,031,007,013,015,004,003,071,192,192,240,192,096,224
DB 064,128,071,003,003,015,003,006,007,002,001,071,224,224,248,224
DB 240,240,224,192,071,003,003,015,003,006,007,002,001,071,224,224
DB 248,224,240,240,224,192,071,007,007,031,007,015,015,007,003,071
DB 192,192,240,192,096,224,064,128,071,007,007,031,007,015,015,007
DB 003,071,192,192,240,192,096,224,064,128,071,007,007,031,000,008
DB 008,000,003,071,192,192,240,000,032,032,000,128,071,003,003,015
DB 000,004,004,000,001,071,224,224,248,000,016,016,000,192,071,013
DB 029,053,037,007,006,014,000,068,208,216,200,208,240,112,048,056
DB 068,011,027,019,011,015,014,012,028,068,176,184,172,164,224,096
DB 112,000,068,007,013,027,003,003,001,002,006,068,240,232,232,224
DB 224,224,224,224,068,007,011,011,003,001,001,003,007,068,176,216
DB 236,224,224,208,144,176,068,015,023,023,007,007,007,007,007,068
DB 224,176,216,192,192,128,064,096,068,013,027,055,007,007,011,009
DB 013,068,224,208,208,192,128,128,192,224,068,013,030,031,015,015
DB 014,012,028,068,096,216,216,216,224,096,112,000,068,006,027,027
DB 027,007,006,014,000,068,176,120,248,240,240,112,048,056,068,000
DB 000,007,031,047,045,115,126,066,000,000,192,240,232,104,156,252
DB 066,000,003,015,023,023,053,059,062,066,000,128,224,208,208,088
DB 184,248,066,000,000,007,025,053,043,103,126,067,000,000,192,048
DB 088,168,204,252,067,000,003,015,025,021,053,051,062,067,000,128
DB 224,048,080,088,152,248,067,000,000,007,031,063,063,119,127,067
DB 000,000,192,240,248,248,220,252,067,000,003,015,031,031,063,059
DB 063,067,000,128,224,240,240,248,184,248,067,000,000,007,031,063
DB 063,099,127,067,000,000,192,240,248,248,140,252,067,000,003,015
DB 031,027,059,059,063,067,000,128,224,240,176,184,184,248,067,125
DB 126,063,059,028,007,001,000,066,124,252,248,184,112,192,016,224
DB 066,061,061,062,027,027,012,003,001,066,120,120,248,176,176,096
DB 176,192,066,125,126,063,056,031,007,001,000,067,124,252,248,056
DB 240,192,016,224,067,061,061,062,031,028,015,003,001,067,120,120
DB 248,240,112,224,176,192,067,125,126,063,062,029,007,001,000,067
DB 124,252,248,248,112,192,016,224,067,063,059,060,031,028,011,003
DB 001,067,248,184,120,240,112,160,176,192,067,095,092,047,051,028
DB 007,001,000,067,244,116,232,152,112,192,016,224,067,062,054,054
DB 027,028,015,003,001,067,248,216,216,176,112,224,176,192,067,239
DB 127,255,251,254,237,250,245,071,253,255,255,222,127,183,095,175
DB 071,125,239,187,255,221,119,254,219,071,239,125,215,125,239,187
DB 254,239,071,085,239,186,109,213,119,170,219,071,171,061,215,093
DB 230,185,214,107,071,085,165,144,077,081,085,168,138,071,171,040
DB 069,009,162,040,086,105,071,068,164,128,069,065,020,168,130,071
DB 170,032,069,001,000,040,066,065,071,068,160,000,069,065,016,168
DB 130,071,162,032,069,001,000,040,066,000,071,064,160,000,065,000
DB 000,136,130,071,032,000,000,001,000,032,064,000,071,000,128,000
DB 065,000,000,008,002,071,032,000,000,001,000,032,000,000,071,245
DB 250,237,254,123,255,255,191,071,175,095,183,127,223,255,254,247
DB 071,126,215,253,183,253,239,187,238,071,191,250,223,245,191,237
DB 191,251,071,042,215,109,146,189,074,185,110,071,181,106,091,181
DB 154,237,183,234,071,008,213,069,018,153,010,185,102,071,149,072
DB 083,053,138,169,179,098,071,008,197,068,016,025,002,169,070,071
DB 000,008,017,020,002,041,001,034,071,008,128,068,016,009,002,041
DB 004,071,000,008,016,004,000,009,001,034,071,008,128,004,000,009
DB 002,032,004,071,000,008,016,004,000,009,000,034,071,000,128,004
DB 000,001,000,032,004,071,000,008,000,000,000,009,000,032,071,144
DB 000,090,000,060,066,064,060,002,066,060,000,071,060,066,064,064
DB 064,066,060,000,071,060,066,066,066,066,066,060,000,071,124,066
DB 066,124,072,068,066,000,071,126,064,064,120,064,064,126,000,071
DB 124,066,066,124,066,066,124,000,071,060,066,066,066,066,066,060
DB 000,071,066,098,082,074,070,066,066,000,071,066,066,066,066,066
DB 066,060,000,071,060,066,064,060,002,066,060,000,071,032,001,064
DB 002,000,000,000,000,000,000,000,000,064,024,024,024,000,024,024
DB 024,000,071,128,000,007,031,053,059,117,127,066,000,000,192,240
DB 088,184,092,252,066,000,000,007,031,053,059,117,064,066,000,000
DB 192,240,088,184,092,060,066,000,000,007,031,053,059,064,064,066
DB 000,000,192,240,088,184,028,028,066,000,000,007,031,053,000,000
DB 000,066,000,000,128,128,008,008,012,012,066,000,000,000,007,023
DB 061,000,000,066,000,000,000,192,000,008,008,012,066,000,000,000
DB 000,000,000,000,000,064,000,000,000,000,000,000,000,000,064,000
DB 000,000,000,000,000,000,000,064,000,000,000,000,000,000,000,000
DB 064,062,008,008,008,008,008,008,000,071,028,034,064,078,066,034
DB 028,000,071,127,120,060,060,029,007,001,000,066,124,124,120,056
DB 240,192,016,224,066,064,120,056,056,025,001,001,000,066,060,060
DB 000,000,240,192,016,224,066,064,112,048,048,016,003,001,000,066
DB 028,028,000,000,000,192,016,224,066,096,096,032,032,000,000,001
DB 000,066,012,012,008,000,000,000,016,224,066,000,000,096,032,032
DB 003,001,000,066,012,012,012,000,000,192,016,224,066,007,031,053
DB 000,000,096,121,000,066,128,128,008,008,012,012,000,240,066,000
DB 000,000,003,015,021,108,087,066,000,000,000,128,128,028,030,224
DB 066,000,000,123,107,107,107,123,000,068,000,000,094,076,076,076
DB 204,000,068,000,000,000,000,000,000,001,003,069,000,000,000,000
DB 000,000,192,024,069,000,000,000,000,000,008,024,024,069,000,000
DB 000,000,000,124,180,220,069,000,000,000,000,000,000,064,096,069
DB 000,000,000,000,124,180,220,180,069,000,000,000,001,002,007,004
DB 006,069,000,000,000,128,192,224,160,192,069,000,000,001,002,007
DB 004,004,003,070,000,000,128,192,224,160,192,128,070,000,000,000
DB 007,013,015,006,004,070,000,000,000,192,096,224,192,064,070,000
DB 000,007,013,015,006,004,003,070,000,000,192,096,224,192,064,128
DB 070,000,000,240,224,096,063,063,030,069,000,000,028,062,034,127
DB 107,062,069,006,015,011,011,011,011,030,120,071,044,094,122,108
DB 056,128,240,060,071,024,027,011,011,011,011,030,120,069,180,124
DB 190,188,160,160,240,060,069,048,027,011,011,011,014,028,056,069
DB 124,190,188,160,160,224,112,056,069,003,251,123,011,011,014,028
DB 056,069,128,190,188,160,160,224,112,056,069,027,059,107,075,015
DB 014,012,028,069,176,184,172,164,224,224,096,112,069,251,251,011
DB 011,015,014,012,028,069,190,190,160,160,224,224,096,112,069,027
DB 059,107,075,015,014,012,028,069,176,184,172,164,224,224,096,112
DB 069,090,000,018,000,030,029,030,031,028,031,016,031,066,208,080
DB 048,240,208,048,016,240,066,234,000,018,000,031,030,031,031,027
DB 023,023,024,066,048,208,048,240,176,208,208,048,066,090,000,018
DB 000,130,034,018,018,035,000,127,071,071,000,000,016,016,144,000
DB 248,143,071,234,000,018,000,111,107,121,122,123,127,048,031,071
DB 217,089,121,126,120,248,048,224,071,090,000,018,000,000,000,001
DB 007,031,016,016,020,068,000,000,252,254,254,004,020,020,068,234
DB 000,018,000,022,020,120,143,096,144,144,096,068,036,228,231,248
DB 006,009,009,006,068,090,000,018,000,000,000,000,000,000,001,030
DB 029,071,008,020,040,080,160,064,128,128,071,234,000,018,000,027
DB 023,031,031,031,015,006,015,071,128,128,128,128,164,036,036,024
DB 071,090,000,018,000,032,064,040,040,020,008,048,000,071,000,000
DB 000,000,000,000,000,014,067,234,000,018,000,252,252,120,127,126
DB 060,000,000,067,057,096,192,128,000,000,000,000,067,090,000,018
DB 000,015,126,030,015,015,031,061,120,070,030,033,209,014,128,224
DB 120,060,070,234,000,018,000,117,117,248,253,245,248,125,063,070
DB 092,124,062,094,094,062,124,248,070,090,000,018,000,000,000,000
DB 015,229,255,255,225,071,000,000,000,128,002,254,252,128,071,234
DB 000,018,000,003,007,008,008,016,016,032,032,066,192,224,144,144
DB 136,072,068,068,066,090,000,018,000,014,008,008,004,007,004,031
DB 036,071,000,000,000,120,240,048,008,136,071,234,000,018,000,068
DB 132,132,128,128,064,032,031,071,072,036,036,036,038,073,137,006
DB 071


   PRESENTA DB   070h,' Proyecto BACTERIA '
            DB 0,01Fh,' Bomberman          '
            DB 0,030h,' Hudson 1983        '
            DB 0,02Fh,' 1.1 '
            DB 0,060h,' 8.267 '
            DB 0,00Eh,' 05/07/01',24



 TECLADO DB 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
   TECLA DB 0FFh

 IRQ9SEG DW ?
 IRQ9OFF DW ?
END START
